module Uart_Bus #
(
parameter				BPS_PARA = 1250 	//12MHzʱʱ1250Ӧ9600Ĳ
)
(
input					clk,			//ϵͳʱ 12MHz
input					rst_n,			//ϵͳλЧ

input					uart_rx,		//UART
output					rx_data_valid,	//Ч
output			[7:0]	rx_data_out,	//յ

input					tx_data_valid,	//Ч
input			[7:0]	tx_data_in,		//Ҫ͵
output					uart_tx			//UART
);	
	
/////////////////////////////////UARTչģ////////////////////////////////////

wire					bps_en_rx,bps_clk_rx;

//UARTղʱӿģ 
Baud #
(
.BPS_PARA				(BPS_PARA		)
)
Baud_rx
(	
.clk					(clk			),	//ϵͳʱ 12MHz
.rst_n					(rst_n			),	//ϵͳλЧ
.bps_en					(bps_en_rx		),	//ʱʹ
.bps_clk				(bps_clk_rx		)	//ʱ
);

//UARTģ 
Uart_Rx Uart_Rx_uut
(
.clk					(clk			),	//ϵͳʱ 12MHz
.rst_n					(rst_n			),	//ϵͳλЧ

.bps_en					(bps_en_rx		),	//ʱʹ
.bps_clk				(bps_clk_rx		),	//ʱ

.uart_rx				(uart_rx		),	//UART
.rx_data_valid			(rx_data_valid	),	//Ч
.rx_data_out			(rx_data_out	)	//յ
);
	
/////////////////////////////////UART͹ģ////////////////////////////////////
wire					bps_en_tx,bps_clk_tx;

//UARTͲʱӿģ 
Baud #
(
.BPS_PARA				(BPS_PARA		)
)
Baud_tx
(
.clk					(clk			),	//ϵͳʱ 12MHz
.rst_n					(rst_n			),	//ϵͳλЧ
.bps_en					(bps_en_tx		),	//ʱʹ
.bps_clk				(bps_clk_tx		)	//ʱ
);

//UARTģ 
Uart_Tx Uart_Tx_uut
(
.clk					(clk			),	//ϵͳʱ 12MHz
.rst_n					(rst_n			),	//ϵͳλЧ

.bps_en					(bps_en_tx		),	//ʱʹ
.bps_clk				(bps_clk_tx		),	//ʱ

.tx_data_valid			(tx_data_valid	),	//Ч
.tx_data_in				(tx_data_in		),	//Ҫ͵
.uart_tx				(uart_tx		)	//UART
);

endmodule
