module Uart_Tx
(
input					clk,			//ϵͳʱ 12MHz
input					rst_n,			//ϵͳλЧ

output	reg				bps_en,			//ʱʹ
input					bps_clk,		//ʱ

input					tx_data_valid,	//Ч
input			[7:0]	tx_data_in,		//Ҫ͵
output	reg				uart_tx			//UART
);

reg				[3:0]	num;
reg				[9:0]	tx_data_r;	//ںʼλֹͣλ
//ݲ
always @ (posedge clk or negedge rst_n) begin
	if(!rst_n) begin
		bps_en <= 1'b0;
		tx_data_r <= 10'd0;
	end else if(tx_data_valid && (!bps_en))begin	
		bps_en <= 1'b1;		//⵽ʱʹźŵ½أɣҪݣʹܷʱʹź
		tx_data_r <= {1'b1,tx_data_in,1'b0};	
	end else if(num==4'd10) begin	
		bps_en <= 1'b0;		//һUARTҪ10ʱźţȻ
	end
end

//ڹ״̬ʱշʱӵĽķ
always @ (posedge clk or negedge rst_n) begin
	if(!rst_n) begin
		num <= 1'b0;
		uart_tx <= 1'b1;
	end else if(bps_en) begin
		if(bps_clk) begin
			num <= num + 1'b1;
			uart_tx <= tx_data_r[num];
		end else if(num>=4'd10) begin
			num <= 4'd0;	
		end
	end
end

endmodule